> For the complete documentation index, see [llms.txt](https://docs.platform9.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.platform9.com/api-docs/block-storage-service/groups.md).

# Groups

Generic volume group management

## List groups

> Lists all generic volume groups

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"groups","description":"Generic volume group management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"parameters":{"AllTenantsQuery":{"name":"all_tenants","description":"Shows details for all project. Admin only.","schema":{"type":"string"},"in":"query"},"SortQuery":{"name":"sort","description":"Comma-separated list of sort keys and optional sort directions","schema":{"type":"string"},"in":"query"},"SortKeyQuery":{"name":"sort_key","description":"Sorts by an attribute","schema":{"type":"string"},"in":"query"},"SortDirQuery":{"name":"sort_dir","description":"Sorts by direction (asc or desc)","schema":{"enum":["asc","desc"],"type":"string"},"in":"query"},"LimitQuery":{"name":"limit","description":"Requests a page size of items","schema":{"minimum":1,"type":"integer"},"in":"query"},"OffsetQuery":{"name":"offset","description":"Used in conjunction with limit to return items starting from the offset position","schema":{"minimum":0,"type":"integer"},"in":"query"},"MarkerQuery":{"name":"marker","description":"The ID of the last-seen item","schema":{"type":"string"},"in":"query"}},"schemas":{"GroupsSimple":{"type":"object","properties":{"groups":{"type":"array","items":{"$ref":"#/components/schemas/GroupSimple"}}}},"GroupSimple":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the group","type":"string"},"name":{"nullable":true,"description":"The group name","type":"string"}}}}},"paths":{"/v3/groups":{"get":{"tags":["groups"],"parameters":[{"$ref":"#/components/parameters/AllTenantsQuery"},{"$ref":"#/components/parameters/SortQuery"},{"$ref":"#/components/parameters/SortKeyQuery"},{"$ref":"#/components/parameters/SortDirQuery"},{"$ref":"#/components/parameters/LimitQuery"},{"$ref":"#/components/parameters/OffsetQuery"},{"$ref":"#/components/parameters/MarkerQuery"}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GroupsSimple"}}},"description":"OK"}},"summary":"List groups","description":"Lists all generic volume groups"}}}}
```

## Create group

> Creates a generic volume group

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"groups","description":"Generic volume group management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"GroupCreateRequest":{"type":"object","properties":{"group":{"required":["group_type","volume_types"],"type":"object","properties":{"name":{"description":"The group name","type":"string"},"description":{"description":"The group description","type":"string"},"group_type":{"description":"The group type","type":"string"},"volume_types":{"description":"List of volume type names or IDs","type":"array","items":{"type":"string"}},"availability_zone":{"description":"The availability zone","type":"string"}}}}},"GroupResponse":{"type":"object","properties":{"group":{"$ref":"#/components/schemas/Group"}}},"Group":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the group","type":"string"},"name":{"nullable":true,"description":"The group name","type":"string"},"description":{"nullable":true,"description":"The group description","type":"string"},"status":{"description":"The group status","type":"string"},"availability_zone":{"nullable":true,"description":"The availability zone","type":"string"},"group_type":{"description":"The group type","type":"string"},"group_snapshot_id":{"nullable":true,"format":"uuid","description":"The UUID of the source group snapshot","type":"string"},"source_group_id":{"nullable":true,"format":"uuid","description":"The UUID of the source group","type":"string"},"volume_types":{"description":"List of volume type IDs","type":"array","items":{"type":"string"}},"volumes":{"description":"List of volume UUIDs","type":"array","items":{"format":"uuid","type":"string"}},"created_at":{"format":"date-time","description":"The date and time when the resource was created","type":"string"},"user_id":{"format":"uuid","description":"The UUID of the user","type":"string"},"project_id":{"format":"uuid","description":"The UUID of the project","type":"string"}}}}},"paths":{"/v3/groups":{"post":{"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GroupCreateRequest"}}},"required":true},"tags":["groups"],"responses":{"202":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GroupResponse"}}},"description":"Accepted"}},"summary":"Create group","description":"Creates a generic volume group"}}}}
```

## List groups with details

> Lists all generic volume groups with details

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"groups","description":"Generic volume group management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"parameters":{"AllTenantsQuery":{"name":"all_tenants","description":"Shows details for all project. Admin only.","schema":{"type":"string"},"in":"query"},"SortQuery":{"name":"sort","description":"Comma-separated list of sort keys and optional sort directions","schema":{"type":"string"},"in":"query"},"SortKeyQuery":{"name":"sort_key","description":"Sorts by an attribute","schema":{"type":"string"},"in":"query"},"SortDirQuery":{"name":"sort_dir","description":"Sorts by direction (asc or desc)","schema":{"enum":["asc","desc"],"type":"string"},"in":"query"},"LimitQuery":{"name":"limit","description":"Requests a page size of items","schema":{"minimum":1,"type":"integer"},"in":"query"},"OffsetQuery":{"name":"offset","description":"Used in conjunction with limit to return items starting from the offset position","schema":{"minimum":0,"type":"integer"},"in":"query"},"MarkerQuery":{"name":"marker","description":"The ID of the last-seen item","schema":{"type":"string"},"in":"query"}},"schemas":{"GroupsDetail":{"type":"object","properties":{"groups":{"type":"array","items":{"$ref":"#/components/schemas/Group"}}}},"Group":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the group","type":"string"},"name":{"nullable":true,"description":"The group name","type":"string"},"description":{"nullable":true,"description":"The group description","type":"string"},"status":{"description":"The group status","type":"string"},"availability_zone":{"nullable":true,"description":"The availability zone","type":"string"},"group_type":{"description":"The group type","type":"string"},"group_snapshot_id":{"nullable":true,"format":"uuid","description":"The UUID of the source group snapshot","type":"string"},"source_group_id":{"nullable":true,"format":"uuid","description":"The UUID of the source group","type":"string"},"volume_types":{"description":"List of volume type IDs","type":"array","items":{"type":"string"}},"volumes":{"description":"List of volume UUIDs","type":"array","items":{"format":"uuid","type":"string"}},"created_at":{"format":"date-time","description":"The date and time when the resource was created","type":"string"},"user_id":{"format":"uuid","description":"The UUID of the user","type":"string"},"project_id":{"format":"uuid","description":"The UUID of the project","type":"string"}}}}},"paths":{"/v3/groups/detail":{"get":{"tags":["groups"],"parameters":[{"$ref":"#/components/parameters/AllTenantsQuery"},{"$ref":"#/components/parameters/SortQuery"},{"$ref":"#/components/parameters/SortKeyQuery"},{"$ref":"#/components/parameters/SortDirQuery"},{"$ref":"#/components/parameters/LimitQuery"},{"$ref":"#/components/parameters/OffsetQuery"},{"$ref":"#/components/parameters/MarkerQuery"}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GroupsDetail"}}},"description":"OK"}},"summary":"List groups with details","description":"Lists all generic volume groups with details"}}}}
```

## Show group details

> Shows details for a group

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"groups","description":"Generic volume group management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"GroupResponse":{"type":"object","properties":{"group":{"$ref":"#/components/schemas/Group"}}},"Group":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the group","type":"string"},"name":{"nullable":true,"description":"The group name","type":"string"},"description":{"nullable":true,"description":"The group description","type":"string"},"status":{"description":"The group status","type":"string"},"availability_zone":{"nullable":true,"description":"The availability zone","type":"string"},"group_type":{"description":"The group type","type":"string"},"group_snapshot_id":{"nullable":true,"format":"uuid","description":"The UUID of the source group snapshot","type":"string"},"source_group_id":{"nullable":true,"format":"uuid","description":"The UUID of the source group","type":"string"},"volume_types":{"description":"List of volume type IDs","type":"array","items":{"type":"string"}},"volumes":{"description":"List of volume UUIDs","type":"array","items":{"format":"uuid","type":"string"}},"created_at":{"format":"date-time","description":"The date and time when the resource was created","type":"string"},"user_id":{"format":"uuid","description":"The UUID of the user","type":"string"},"project_id":{"format":"uuid","description":"The UUID of the project","type":"string"}}}}},"paths":{"/v3/groups/{group_id}":{"get":{"tags":["groups"],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GroupResponse"}}},"description":"OK"}},"summary":"Show group details","description":"Shows details for a group"}}}}
```

## Update group

> Updates a group

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"groups","description":"Generic volume group management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"GroupUpdateRequest":{"type":"object","properties":{"group":{"type":"object","properties":{"name":{"description":"The group name","type":"string"},"description":{"description":"The group description","type":"string"},"add_volumes":{"description":"Comma-separated list of volume UUIDs to add","type":"string"},"remove_volumes":{"description":"Comma-separated list of volume UUIDs to remove","type":"string"}}}}},"GroupResponse":{"type":"object","properties":{"group":{"$ref":"#/components/schemas/Group"}}},"Group":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the group","type":"string"},"name":{"nullable":true,"description":"The group name","type":"string"},"description":{"nullable":true,"description":"The group description","type":"string"},"status":{"description":"The group status","type":"string"},"availability_zone":{"nullable":true,"description":"The availability zone","type":"string"},"group_type":{"description":"The group type","type":"string"},"group_snapshot_id":{"nullable":true,"format":"uuid","description":"The UUID of the source group snapshot","type":"string"},"source_group_id":{"nullable":true,"format":"uuid","description":"The UUID of the source group","type":"string"},"volume_types":{"description":"List of volume type IDs","type":"array","items":{"type":"string"}},"volumes":{"description":"List of volume UUIDs","type":"array","items":{"format":"uuid","type":"string"}},"created_at":{"format":"date-time","description":"The date and time when the resource was created","type":"string"},"user_id":{"format":"uuid","description":"The UUID of the user","type":"string"},"project_id":{"format":"uuid","description":"The UUID of the project","type":"string"}}}}},"paths":{"/v3/groups/{group_id}":{"put":{"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GroupUpdateRequest"}}},"required":true},"tags":["groups"],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GroupResponse"}}},"description":"OK"}},"summary":"Update group","description":"Updates a group"}}}}
```

## Delete group

> Deletes a group

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"groups","description":"Generic volume group management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"responses":{"Accepted":{"description":"Request is accepted, but processing may take some time"}}},"paths":{"/v3/groups/{group_id}":{"delete":{"tags":["groups"],"parameters":[{"name":"delete-volumes","description":"Also delete volumes in the group","schema":{"default":false,"type":"boolean"},"in":"query"}],"responses":{"202":{"$ref":"#/components/responses/Accepted"}},"summary":"Delete group","description":"Deletes a group"}}}}
```

## Perform group action

> Performs various actions on a group

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"groups","description":"Generic volume group management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"CreateGroupSnapshotRequest":{"type":"object","properties":{"create-group-snapshot":{"type":"object","properties":{"name":{"description":"The group snapshot name","type":"string"},"description":{"description":"The group snapshot description","type":"string"}}}}},"DeleteGroupSnapshotRequest":{"type":"object","properties":{"delete-group-snapshot":{"required":["group_snapshot"],"type":"object","properties":{"group_snapshot":{"format":"uuid","description":"The UUID of the group snapshot","type":"string"}}}}},"ResetGroupStatusRequest":{"type":"object","properties":{"reset_status":{"required":["status"],"type":"object","properties":{"status":{"description":"The group status","type":"string"}}}}},"EnableGroupReplicationRequest":{"type":"object","properties":{"enable_replication":{"type":"object"}}},"DisableGroupReplicationRequest":{"type":"object","properties":{"disable_replication":{"type":"object"}}},"FailoverGroupReplicationRequest":{"type":"object","properties":{"failover_replication":{"type":"object","properties":{"allow_attached_volume":{"description":"Allow attached volumes to be failed over","type":"boolean"},"secondary_backend_id":{"description":"Secondary backend ID","type":"string"}}}}},"ListGroupReplicationTargetsRequest":{"type":"object","properties":{"list_replication_targets":{"type":"object"}}}},"responses":{"Accepted":{"description":"Request is accepted, but processing may take some time"}}},"paths":{"/v3/groups/{group_id}/action":{"post":{"requestBody":{"content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/CreateGroupSnapshotRequest"},{"$ref":"#/components/schemas/DeleteGroupSnapshotRequest"},{"$ref":"#/components/schemas/ResetGroupStatusRequest"},{"$ref":"#/components/schemas/EnableGroupReplicationRequest"},{"$ref":"#/components/schemas/DisableGroupReplicationRequest"},{"$ref":"#/components/schemas/FailoverGroupReplicationRequest"},{"$ref":"#/components/schemas/ListGroupReplicationTargetsRequest"}]}}},"required":true},"tags":["groups"],"responses":{"200":{"content":{"application/json":{"schema":{"type":"object"}}},"description":"OK (for list operations)"},"202":{"$ref":"#/components/responses/Accepted"}},"summary":"Perform group action","description":"Performs various actions on a group"}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.platform9.com/api-docs/block-storage-service/groups.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
